
#ifdef FIKE_IMP_SERVER

typedef struct fike_client FIKE_CLIENT;

/*** SERVER SIDE CALLBACKS ***/
void* fike_client_connected(char *host, int port, int fd);
void fike_client_disconnected(char *host, int port, void *udata);
void fike_client_message(FIKE_CLIENT *cc,void *usr, int cmd);

int fike_publish(char *iface,char *name, int type, int port);
int fike_command_params(FIKE_CLIENT *cc, const char *fmt, ...);
int fike_command_rest(FIKE_CLIENT *cc, unsigned char **Rd, unsigned int *Rl);
void fike_close_client(FIKE_CLIENT *cc);
int fike_response(FIKE_CLIENT *cc, const char* fmt, ...);

#endif

#ifdef FIKE_IMP_CLIENT

typedef struct fike_server FIKE_SERVER;

/*** CLIENT SIDE CALLBACK ***/
void fike_found_server
               (char *host, uint32_t addr, int port, int type, char *name);

int fike_start_query(char *iface,char *pattern);
void fike_stop_query();
FIKE_SERVER* fike_connect(uint32_t addr, int port);
int fike_command
  (FIKE_SERVER *server, int response, int cmd, const char* fmt, ...);
int fike_response_params(FIKE_SERVER *cc, const char *fmt, ...);
int fike_response_rest(FIKE_SERVER *cc, unsigned char **Rd, unsigned int *Rl);
void fike_close_server(FIKE_SERVER *ss);

#endif


extern void (*fike_error_output)(const char *data, int len);

uint32_t fike_get_network_interface_address(char *iface);
char** fike_get_network_interfaces(int filter_loopback);
void fike_free_network_interfaces(char **K);

/*** COMMON CALLBACKS ***/
void fike_add_fd(int fd);
void fike_remove_fd(int fd);

int fike_n_fds();
int fike_fd(int idx) ;
int fike_get_select(fd_set *rset, fd_set *xset);
void fike_process_select(fd_set *rset, fd_set *xset);

